/**
 * Der Preloader lädt auf einigen Geräten alle
 * benötigten Grafiken vor, damit diese nicht
 * on the fly geladen werden müssen. Die UI
 * würde sonst zu sehr flackern. Das geht
 * aber nur bei Geräten mit ausreichend
 * Grafikspeicher
 */
var Preloader = {
  'images' : [
      'artistinfo/artist_info.png',
      'artistinfo/platzhalter.png',
      'channelinfo/background.png',
      'channelview/aktiv_button.png',
      'channelview/bewerten_back.png',
      'channelview/bewerten_button.png',
      'channelview/bewerten_step0.png',
      'channelview/bewerten_step1.png',
      'channelview/bewerten_step2.png',
      'channelview/bewerten_step3.png',
      'channelview/bewerten_step4.png',
      'channelview/bewerten_step5.png',
      'channelview/channel_back.png',
      'channelview/info_artistinfo_button.png',
      'channelview/info_back.png',
      'channelview/info_button.png',
      'channelview/info_channelinfo_button.png',
      'channelview/programm_button.png',
      'channelview/skip_button.png',
      'channelview/vq_button.png',
      'user/bg.png',
      'user/button_big_aktiv.png',
      'user/button_big_inaktiv.png',
      'veequalizer/background.png',
      'veequalizer/box.png',
      'veequalizer/button_small_aktiv.png',
      'veequalizer/button_small_inaktiv.png',
      'veequalizer/decade.png',
      'veequalizer/decade_00er.png',
      'veequalizer/decade_00er_aktiv.png',
      'veequalizer/decade_70er.png',
      'veequalizer/decade_70er_aktiv.png',
      'veequalizer/decade_80er.png',
      'veequalizer/decade_80er_aktiv.png',
      'veequalizer/decade_90er.png',
      'veequalizer/decade_90er_aktiv.png',
      'veequalizer/decade_active.png',
      'veequalizer/decade_heute.png',
      'veequalizer/decade_heute_aktiv.png',
      'veequalizer/hated.png',
      'veequalizer/los.png',
      'veequalizer/los_aktiv.png',
      'veequalizer/ok.png',
      'veequalizer/ok_aktiv.png',
      'veequalizer/selektor_big.png',
      'veequalizer/selektor_small.png',
      'veequalizer/selektor_tiny.png',
      'veequalizer/slider.png',
      'veequalizer/slider_aktiv.png',
      'veequalizer/textbackground.png',
      'veequalizer/textfeld.png',
      'veequalizer/textfeld_aktiv.png',
      'veequalizer/textfeld_deaktiviert.png',
      'veequalizer/textfeld_deaktiviert_aktiv.png',
      'veequalizer/umrandung.png',
      'veequalizer/verbannt.png',
      'veequalizer/verbannt_aktiv.png',
      'back_white.png',
      'back_blue.png'
    ],

  'images_small_ui' : [
    'veequalizer/vq_balken.png',
    'veequalizer/vq_kachel.png',
    'artistinfo/corner.png',
    'channelinfo/corner.png'
  ],

  'images_large_ui' : [
    'veequalizer/vq_gehaeuse.png'
  ],

  'keyboard' : [
    'keyboard/0.png',
    'keyboard/0_aktiv.png',
    'keyboard/1.png',
    'keyboard/1_aktiv.png',
    'keyboard/2.png',
    'keyboard/2_aktiv.png',
    'keyboard/3.png',
    'keyboard/3_aktiv.png',
    'keyboard/4.png',
    'keyboard/4_aktiv.png',
    'keyboard/5.png',
    'keyboard/5_aktiv.png',
    'keyboard/6.png',
    'keyboard/6_aktiv.png',
    'keyboard/7.png',
    'keyboard/7_aktiv.png',
    'keyboard/8.png',
    'keyboard/8_aktiv.png',
    'keyboard/9.png',
    'keyboard/9_aktiv.png',
    'keyboard/loeschen.png',
    'keyboard/loeschen_aktiv.png',
    'keyboard/ok.png'
   ],

  'cache' : [],

  'loadImages' : function() { 
      if (Device.smallUI) {
        Preloader.images.concat(Preloader.images_small_ui);
      } else {
        Preloader.images.concat(Preloader.images_large_ui);
      }

      if (Device.needsOnScreenKeyboard) {
        Preloader.images.concat(Preloader.keyboard);
      }

      var html = "<div id='preloading' style='display:none'>";

      for ( var i = 0; i < Preloader.images.length; i++ ) {
        var img = new Image();
        img.src = Positions.size + "images/" + Preloader.images[i];
        Preloader.cache.push(img);
        html += "<img src='"+img.src+"'/>";
      }

      html += "</div>";

      widgetAPI.putInnerHTML(document.getElementById('body'), html);
  }
};
