/**
 * Das komplette Tracking in Putpat wird hierrüber gemacht
 * Google Tracking via trackAction, rp Tracking via trackPutpat und
 * das neue stats Tracking via trackStat
 */
var Tracking = function() {
  var TRACKING_ID = "UA-8423274-3";
  var self = {};
  var images = [];

  self.init = function() {
  };

  // Google Analytics tracking
  self.trackAction = function(category, action, label) {
    try {
      if (Device.trackingEnabled) {
        var trackThis = "5("+category+"*"+action;
        var randomId = Math.floor(Math.random(10)*100000);
        if (label != null) {
          trackThis += "*" + label;
        }
        trackThis += ")";

        var urlPath = "https://ssl.google-analytics.com/__utm.gif?"+
          "utmwv=5.3.2&utmn="+ randomId+"&"+
          "utmcs=UTF-8&utmdt=Putpat&utmhid="+randomId+"&"+
          "utmac="+TRACKING_ID+"&"+
          "utmt=event&utme="+encodeURIComponent(trackThis)+"&" +
          "utmcc=__utma%3D1."+randomId+"00145214523."+randomId+"."+new Date().getTime()+"."+new Date().getTime()+".15%3B%2B"+
          "__utmz%3D1."+new Date().getTime()+".1.1.utmcsr%3D(direct)%7Cutmccn%3D(direct)%7Cutmcmd%3D(none)%3B"+
          "&aip=1";

        sendTrack(urlPath);
      }
    } catch(e) {
      Putpat.reportError(e, "unkown", "tracking#trackAction", "");
    }
  };

  // Altes Putpat Tracking
  self.trackPutpat = function(type, value) {
    try {
      if (Device.trackingEnabled) {
        var urlPath = "http://rp.putpat.tv/tracking?random=" + new Date().getTime() + "&type="+ type +
          "&value="+value+"&client=" + CLIENT_STRING + "&player_id=" + Putpat.getPlayerId();
          sendTrack(urlPath);
      }
    } catch(e) {
      Putpat.reportError(e, "unkown", "tracking#trackPutpat", "");
    }
  };

  self.trackStat = function(type, value) {
    try {
      if (Device.trackingEnabled) {
        var url = "http://stat.putpat.tv/tracking/"+type+"?r=" + new Date().getTime() + 
          "&client=" + CLIENT_STRING + "&player_id=" + Putpat.getPlayerId();
          if (value) {
            url += "&" + value;
          }

        sendTrack(url);
      }
    } catch(e) {
      Putpat.reportError(e, "unkown", "tracking#trackStat", "");
    }
  };

  self.trackUrl = function(urls) {
    try {
      if (Device.trackingEnabled) {
        sendTrack(urls);
      }
    } catch(e) {
      Putpat.reportError(e, "unkown", "tracking#trackUrl", "");
    }
  };

  sendTrack = function(url) {
    // Tacking als Bild holen
    // ...und dabei die letzten 30 im Speicher halten, damit
    // der Garbage Collector vom Maple Browser da nicht zu 
    // früh dazwischenfunkt
    try {
      var img = new Image();
      img.src = url;
      if (images.push(img) > 30) {
        images.shift();
      }
    } catch(e) {
      Putpat.reportError(e, "unkown", "tracking#sendTrack", "");
    }
  };

  return self;
}();
