/**
 * Die Texteingabe auf den Samsungs benutzt eine Komponente
 * von Samsung. Dabei muss man allerdings etwas vorsichtig beim
 * Abfragen sein. Deswegen gibt es hier an einigen 
 * Stellen eine setTimeout Methode, die später greift, damit
 * die Samsung-Komponente zeit hat, sich zu initialisieren
 */
var Textinput = {

 'currentFocus': null,

 'init' : function(id, value, x, y, keyCallback, completeCallback, enterCallback, initCallback) {
    var self = {};
    var hasFocus = false;
    var oldHandlers = null;

    var shell = new IMEShell(id, function(imeobj) {
        var inputobj = imeobj.getInputObj();
        imeobj.setKeypadPos(parseInt(x),parseInt(y));
        imeobj.setAnyKeyFunc(keyCallback);
        imeobj.setOnCompleteFunc(function() {
          if(typeof completeCallback == 'function' && hasFocus) {
            completeCallback();
          }
        });
        imeobj.setString(value);

        if (enterCallback) {
            imeobj.setEnterFunc(enterCallback);
        }

        if ($("#body_focus").length == 0) {
          $("body").append("<div id='body_focus'></div>");
        }

        document.getElementById(id).blur();
        $("#body_focus").focus();
        $("#"+id).attr("disabled", "disabled");

        if (initCallback) {
          // 2 sek warten, bis das Okay geschickt wird, 
          // damit der TV bisschen Zeit hat, sich mit
          // der Tastatur einzurichten
          setTimeout(function() {
            initCallback(self);
          }, 2000);
        }
    }, "de");

    self.hide = function() {
        shell.hide();
    };

    self.focus = function() {
        hasFocus = true;
        $("#"+id).removeAttr("disabled");
        document.getElementById(id).focus();
        oldHandlers = InputHandler.replaceKeyHandlers();
        Textinput.currentFocus = self;
    };

    self.unfocus = function() {
        Textinput.currentFocus = null;
        hasFocus = false;
        $("#"+id).attr("disabled","disabled");
        document.getElementById(id).blur();
        $("#body_focus").focus();
        if (oldHandlers != null) {
          InputHandler.replaceKeyHandlers(oldHandlers);
        }
    };

    self.setText = function(value) {
      shell.setString(value);
    }

    return self;
  }
};
