/**
 * Der Maple Browser kann nur einen einzigen XMLHttpRequest
 * gleichzeitig, und deswegen gibt es hier diese Klasse.
 * Es wird immer nur ein Request erlaubt. Wenn ein zweiter
 * kommt, wird dieser erst verarbeitet, wenn der erste
 * zueende ist
 */
var XHRPool = function(){
  var xhrPoolObject = null;
  var xhrPoolLoading = false;

  var queue = [];

  function callXHR(callback){
    xhrPoolLoading = true;
    if (xhrPoolObject != null) {
      xhrPoolObject.destroy();
    }
    xhrPoolObject = new XMLHttpRequest();
    try {
      callback(xhrPoolObject);
    } catch (e) {
      xhrPoolLoading = false;
    }
  }

  return {
    getXHR: function(callback) {
      if (queue.length == 0 && !xhrPoolLoading) {
        callXHR(callback);
      } else {
        queue.push(callback);
      }
    },

    done: function(xhr) {
      xhrPoolLoading = false;
      if (queue.length > 0) {
        callXHR(queue.shift());
      }
    }
  };
}();
