/**
 * Die Bauchbinde, was soll ich sagen?
 * Reagiert auf Messages mit "show_bauchbinde" usw
 */
var Bauchbinde = function() {
  var self = {};

  var logoTimer = null;
  var visible = false;
  var showCounter = 0;
  var forceHide = 0;
  var lastOffset = null;

  function messageListener(key, values) {
    try {
      var secondsDiff = 0;

      if (lastOffset != null) {
        secondsDiff = (new Date().getTime() / 1000) - lastOffset;
      }
      lastOffset = new Date().getTime() / 1000;

      if (showCounter > 0) {
        showCounter -= secondsDiff;
        if (showCounter < 0) {
          showCounter = 0;
        }
      }

      if (key == 'new_clip') {
        initBauchbinde();
      } else if (key == 'play_position') {
        if  ((forceHide == 0) &&
            (!isNaN(values.duration) && ((values.pos > 5 && values.pos <= 12) ||
                                         (values.pos > values.duration - 12 && values.pos <= values.duration - 7)))) {
                                           showBauchbinde();
                                         } else if (showCounter == 0) {
                                           hideBauchbinde();
                                         }
      } else if (key == 'show_bauchbinde') {
        showCounter = 10;
        Putpat.debug("show bauchbinde ? " + forceHide);
        if (forceHide <= 0) {
          showBauchbinde();
        }
      } else if (key == 'hide_bauchbinde') {
        showCounter = 0;
        hideBauchbinde();
      } else if (key == 'disable_bauchbinde') {
        forceHide++;
        hideBauchbinde();
      } else if (key == 'enable_bauchbinde') {
        forceHide--;
        if (forceHide < 0) {
          forceHide = 0;
        }
      }
    } catch(e) {
      Putpat.reportError(e, "unkown", "bauchbinde#messageListener", "");
    }
  }

  function initBauchbinde() {
    try {
      var firstLine = "";
      var secondLine = "";
      if (!Utils.isStringEmpty(ChannelView.currentClip.artist)) {
        firstLine = ChannelView.currentClip.artist;
        secondLine = ChannelView.currentClip.title;
      } else {
        firstLine = ChannelView.currentClip.title;
      }

      var color = "#FFFFFF";

      if (Putpat.playerAdvert && Putpat.playerAdvert["bauchbinde"] &&
          Putpat.playerAdvert["bauchbinde"]["color"] &&
          Putpat.playerAdvert["bauchbinde"]["color"][ChannelView.currentChannel.id]) {
            color = Putpat.playerAdvert["bauchbinde"]["color"][ChannelView.currentChannel.id];
          }

      $("#bauchbinde").hide();
      $("#bauchbinde").css("color", color);
      $("#bauchbinde").html(
            "<img id='bauchBack' src='http://files.putpat.tv/artwork/channelgraphics/"+
            ChannelView.currentChannel.id + "/bauchbinde_" + Positions.bauchbinde.size + ".png'/>"+
            "<div class='artist'>"+firstLine+"</div><div class='title'>"+secondLine+"</div>");
      visible = false;
    } catch(e) {
      Putpat.reportError(e, "unkown", "bauchbinde#initBauchbinde", "");
    }
  }

  function showBauchbinde() {
    if (!visible && !LiveEventChannel.curtainVisible()) {
      $("#bauchbinde").show();
      visible = true;
    }
  }

  function hideBauchbinde() {
    if (visible) {
      $("#bauchbinde").hide();
      visible = false;
    }
  }

  MessageQueue.addListener(messageListener);

  self.init = function() {
    $("body").append("<div id='bauchbinde' style='display:hidden'></div>")
  };

  return self;
}();

$(function() {
  Bauchbinde.init();
});
