var VqCompleter = function(vqSlider) {
  var self = {}

  ROW_LENGTH = [10, 10, 5, 4];

  var completer = {};
  var oldHandlers = {};
  var selected = null;
  var selItem = {row: 0, column: 0};
  var textInput = null;
  var oldTextInput = null;
  var lastCompleterRun = null;
  var currentText = null;

  function resetListSelection() {
    selItem.row = 0;
    selItem.column = -1;
    calculateNewColumn(1);
    updateSelection();
  }

  function updateCompleter(force) {
    var newValue = $("#vq_text_input").val();

    if (currentText == newValue) {
      resetListSelection();
      return;
    }
    if (!force && (new Date().getTime() - 500 < lastCompleterRun)) {
      return;
    }

    lastCompleterRun = new Date().getTime();
    Putpat.getCompleter(newValue, function(data) {
       if ($("#vq_text_input").val() != newValue) {
         return
       }
       currentText = newValue
       completer = data;

       var alist = "<ul class='artist_list'>";
       for (var i=0;i< Math.min(10, data['artists'].length); i++) {
          alist += "<li id='list_0_"+i+"' class='text_list_item'><span style='color:#DDDDDD'>"+Utils.replaceWithHTMLEntities(data['artists'][i]['title'])+"</span></li>";
       }
       alist +="</ul>";

       alist += "<ul class='tag_list'>";

       for (var i=0;i< Math.min(10, data['tags'].length); i++) {
            var colorHex = data['tags'][i]['color'];

            var red   = (Math.min(Math.round(parseInt(colorHex.substring(1,3),16) * 1.4),255)).toString(16);
            var green = (Math.min(Math.round(parseInt(colorHex.substring(3,5),16) * 1.4),255)).toString(16);
            var blue  = (Math.min(Math.round(parseInt(colorHex.substring(5,8),16) * 1.4),255)).toString(16);

            var color = "#";
            color += (red.length   == 1 ? "0"+red   : red);
            color += (green.length == 1 ? "0"+green : green);
            color += (blue.length  == 1 ? "0"+blue  : blue);

            alist += "<li id='list_1_"+i+"' class='text_list_item'><span style='color:"+color+"'>"+Utils.replaceWithHTMLEntities(data['tags'][i]['title'])+"</span></li>";
        }
        alist +="</ul>"
        alist += "<ul class='genre_list'>";
        for (var i=0;i< Math.min(5, data['moods'].length); i++) {
            alist += "<li id='list_2_"+i+"' class='text_list_item'><span style='color:#00B6BA'>"+Utils.replaceWithHTMLEntities(data['moods'][i]['title'])+"</span></li>";
        }
        alist +="</ul>"
        alist += "<ul class='mood_list'>";
        for (var i=0;i< Math.min(5, data['dynamic_tags'].length); i++) {
            alist += "<li id='list_3_"+i+"' class='text_list_item'><span style='color:#00A6EF'>"+Utils.replaceWithHTMLEntities(data['dynamic_tags'][i]['title'])+"</span></li>";
        }
        alist +="</ul>"

        $("#vq_completer .list_area").empty().append(alist);
        resetListSelection();
        lastCompleterRun = new Date().getTime();

        $(".text_list_item").mouseover(function() {
          selectList(this.id);
        });

        $(".text_list_item").click(function() {
          selectList(this.id);
          executeButton();
        });
     });
  }

  function selectList(id) {
    selected = "lists"
    var v = new RegExp("list_(\\d*)_(\\d*)").exec(id)
    selItem.row = parseInt(v[2]);
    selItem.column = parseInt(v[1]);
    updateSelection();
  }

  function updateSelection() {
    var selelement = $("#completer_select");

    $("#completer_back").attr("src", Positions.size+"images/completer/bt_back.png");
    $("#vq_text_input").css("border", "2px solid #efefef");

    if (selected == "lists") {
      selelement.css("left", Positions.completer.rows[selItem.column].x +"px");
      selelement.css("top",  Positions.completer.rows[selItem.column].y + (Positions.completer.height * selItem.row) +"px");
      selelement.show();
    } else {
      selelement.hide();
      if (selected == "completer_back") {
        $("#completer_back").attr("src", Positions.size+"images/completer/bt_back_hover.png");
      } else if (selected == "vq_text_input") {
        $("#vq_text_input").css("border", "2px solid #00b4ff");
      }
    }
  }

  function getColumnData(column) {
    var result = [];
    switch (column) {
        case 0: result = completer["artists"];
                break;
        case 1: result = completer["tags"];
                break;
        case 2: result = completer["moods"];
                break;
        case 3: result = completer["dynamic_tags"];
                break;
    }
    return result;
  }

  function getRowCount(column) {
    if (column < 2) {
      return getColumnData(column).length;
    } else {
      return getColumnData(2).length + getColumnData(3).length;
    }
  }

  function moveRow(dir) {
    if (selected == "lists") {
      selItem.row += dir;

      var length = Math.min(ROW_LENGTH[selItem.column], getColumnData(selItem.column).length)

      if (selItem.row < 0) {
        if ((selItem.column <= 2) || (getColumnData(2).length == 0)) {
          selected = "vq_text_input";
          selItem.row = 0;
        } else {
          selItem.row = getColumnData(2).length - 1
          selItem.column = 2;
        }
      } else if (selItem.row >= length) {
         if ((selItem.column != 2) || (getColumnData(3).length == 0)) {
           selItem.row = length - 1;
         } else {
           selItem.column = 3;
           selItem.row = 0;
         }
      }
    } else if ((selected == "vq_text_input" || selected == "completer_back") && dir == 1) {
      selected = "lists"
    }
    updateSelection();
  }

  function calculateNewColumn(dir) {
      // Auf 3-Spaltiges Layout zurückrechen
      if (selItem.column == 3) {
        selItem.column = 2;
        selItem.row += 6;
      }

      do {
        selItem.column += dir;
        if (selItem.column > 2) {
          selItem.column = 0;
        } else if (selItem.column < 0) {
          selItem.column = 2;
        }
      } while (getRowCount(selItem.column) == 0);

      // Und jetzt wieder rumrechen auf 4-Spalten
      var length = Math.min(ROW_LENGTH[selItem.column], getColumnData(selItem.column).length)
      if ((selItem.column != 2) && (selItem.row >= length)) {
        selItem.row = length - 1;
      } else if ((selItem.column == 2) && (selItem.row >= length)){
        selItem.column = 3;
        if (selItem.row > 6) {
          selItem.row -= 6;
          if (selItem.row >= getRowCount(3)) {
            selItem.row = getRowCount(3) - 1;
          }
        } else {
          selItem.row = 0;
        }
      }

  }

  function moveColumn(dir) {
    if (selected == "lists") {
      calculateNewColumn(dir);
    } else if (selected == "vq_text_input") {
      selected = "completer_back";
    } else {
      selected = "vq_text_input";
    }
    updateSelection();
  }

  function executeButton() {
    if (selected == "completer_back") {
      self.hide();
    } else if (selected == "vq_text_input") {
      oldTextInput =  $("#vq_text_input").val();
      textInput.focus();
    } else if (selected == "lists") {
        selected = getColumnData(selItem.column)[selItem.row]
        data = {};

        data["slider_value"] = 80;
        data["title"] = selected["title"];
        data["id"] = selected["id"];
        data["color"] = selected["color"];
        data["type"] = ["artists", "tags", "moods", "dynamic_tags"][selItem.column];

        vqSlider.updateSlider(data);
        self.hide();
    }
  }

  function keyboardHandler(event) {
     switch(event.keyCode) {
         case KEYS.KEY_UP:
             moveRow(-1);
             event.preventDefault();
             break;
         case KEYS.KEY_DOWN:
             moveRow(1);
             event.preventDefault();
             break;
         case KEYS.KEY_LEFT:
             moveColumn(-1);
             event.preventDefault();
             break;
         case KEYS.KEY_RIGHT:
             moveColumn(1);
             event.preventDefault();
             break;
         case KEYS.KEY_ENTER:
             executeButton();
             event.preventDefault();
             break;
         case KEYS.KEY_RETURN:
             self.hide();
             event.preventDefault();
             break;
     }
  }

  function textInputKeyPressed(keycode) {
      switch(keycode) {
          case KEYS.KEY_RETURN:
              if (!Device.backKeyIsDelete) {
                 setTimeout(function() {
                    textInput.setText(oldTextInput);
                    textInput.unfocus();
                    updateCompleter(true);
                 }, 200);
                 return true;
              }
              break;
          case KEYS.KEY_UP:
               return true;
          case KEYS.KEY_ENTER:
               setTimeout(function() {
                 textInput.unfocus();
                 updateCompleter(true);
               }, 200);
               return true;
          case KEYS.KEY_DOWN:
               setTimeout(function() {
                 textInput.unfocus();
                 selected = "lists";
                 updateCompleter(true);
               }, 200);
               return true;
      }
      return false;
  }

  function textEntered() {
    var value = $("#vq_text_input").val();
    updateCompleter();
    setTimeout(function() {
      if (value == $("#vq_text_input").val()) {
        updateCompleter(true);
      }
    }, 500);
  }

  function selectButton(button) {
    selected = button;
    updateSelection();
  }

  function wireMouseEvents(button, id) {
    if (Device.hasMouse) {
      $("#"+button).mouseover(function() {
        Putpat.debug("Mouse OVER" + id);
        selectButton(id)
      });
      $("#"+button).click(function() {
        if (selected != id) {
          selectButton(id)
        };
        executeButton();
      });
    }
  }

  self.show = function() {
    try {
      Tracking.trackAction("user_action", "vq_completer");
      selected = "lists";
      Putpat.trackIvwUi();
      ChannelView.disableAds();
      $("#vq_completer").remove();
      $("#putpat_view").append("<div id='vq_completer'>" +
          "<img src='"+ Positions.size+"images/completer/bg_completer.jpg' class='completer_bg'/>" +
          "<img id='completer_back' src='"+ Positions.size+"images/completer/bt_back.png' class='completer_button'/>" +
          "<img id='completer_select' src='"+ Positions.size+"images/completer/bt_selected_item.png'/>" +
          "<div id='vq_text_input_div'><input size='35' type='text' id='vq_text_input'/></div>" + 
          "<div class='list_area'></div>" +
          "</div>");

      var value = vqSlider.getSlider().title;

      if (value == null || value == undefined || vqSlider.getSlider().slider_value == 0) {
        value = "";
      }

      $("#vq_text_input").val(value);
      updateCompleter(true);
      $("#completer_select").hide();

      oldHandlers = InputHandler.replaceKeyHandlers({
        keyboardHandler: keyboardHandler
      });

      textInput = Textinput.init("vq_text_input",
          value,
          Positions.completer.textinput.x + "px",
          Positions.completer.textinput.y + "px",
          textInputKeyPressed, textEntered);

      wireMouseEvents("completer_back", "completer_back");
      wireMouseEvents("vq_text_input_div", "vq_text_input");
      wireMouseEvents("vq_text_input", "vq_text_input");
    } catch(e) {
      Putpat.reportError(e, "unkown", "vq_completer#show", "");
    }
  };

  self.hide = function() {
    try {
      ChannelView.enableAds();
      textInput.hide();
      InputHandler.replaceKeyHandlers(oldHandlers);
      $("#vq_completer").hide();
      $("#vq_completer img").remove();
    } catch(e) {
      Putpat.reportError(e, "unkown", "vq_completer#hide", "");
    }
  };

  return self;
};
