var VqSlider = function(number) {
  var self = {}
  var slider = null;
  var sliderBaseEl = null;
  var titleEl = null;
  var stickerEl = null;
  var selected = null;
  var mode = null;
  var yearPos = 0;


  function wireMouseEvents(button, id, callback) {
    if (Device.hasMouse) {
      $("#"+button).mouseover(function() {
         Putpat.debug(button);
         ControlBar.unfocus();
         VqPanel.setSelectedSlider(number);
         setSelection(id)
      });
      $("#"+button).click(function(event) {
        ControlBar.unfocus();
        VqPanel.setSelectedSlider(number);
        if (selected != id) {
          setSelection(id)
        };
        if (callback == null || callback == undefined) {
          enterPressed();
        } else {
          callback(event);
        }
      });
    }
  }

  function init() {
    $("#vq_panel").append(
      "<div class='vq_slider' id='vq_slider_"+number+"'>" +
        "<div id='slider_highlight_"+number+"' class='slider_highlight'></div>"+
        "<div id='slider_black_"+number+"'  class='slider_black'></div>"+
        "<div id='decade_highlight_"+number+"_0' class='decade_highlight_0'></div>"+
        "<div id='decade_highlight_"+number+"_1' class='decade_highlight_1'></div>"+
        "<div id='decade_highlight_"+number+"_2' class='decade_highlight_2'></div>"+
        "<div id='decade_highlight_"+number+"_3' class='decade_highlight_3'></div>"+
        "<div id='decade_highlight_"+number+"_4' class='decade_highlight_4'></div>"+
        "<div class='percent' id='slide_percent_div_"+number+"'><span id='slide_percent_"+number+"' class='value'></span>%</div>"+
        "<img src='"+ Positions.size+"images/vq/slider.png' class='slide_bg'/>"+
        "<img id='sticker_"+number+"' src='"+ Positions.size+"images/vq/sticker_normal.png' class='sticker'/>"+
        "<div id='title_div_"+number+"' class='title_div'><table width='100%' height='100%'><tr><td id='title_"+number+"' class='title' valign='center' align='center'></td></tr></table></div>"+
        "<img id='slide_hover_"+number+"' src='"+ Positions.size+"images/vq/slider_hover.png' class='slide_hover'/>"+
        "<img id='decade_hover_"+number+"' src='"+ Positions.size+"images/vq/decade_hover.png' class='decade_hover'/>"+
        "<img id='decade_selector_"+number+"' src='"+ Positions.size+"images/vq/decade_year_hover.png' class='decade_selector'/>"+
        "<img id='sticker_hover_"+number+"' src='"+ Positions.size+"images/vq/sticker_hover.png' class='sticker_hover'/>"+
        "<img id='slider_button_"+number+"' src='"+ Positions.size+"images/vq/slider_button.png' class='slide_button'/>"+
        "<img id='banned_slider_"+number+"' src='"+ Positions.size+"images/vq/banned_slider.png' class='banned_slider'/>"+
      "</div>"
    );

    if (Device.hasMouse) {
      $("#vq_slider_"+number).mousemove(function(event) {
        var x = event.pageX - $("#vq_slider_"+number).offset().left;
        var y = event.pageY - $("#vq_slider_"+number).offset().top;
        if (y > 15 && y < 357 && x > 100 && x < 127) {
           VqPanel.setSelectedSlider(number);
           setSelection("slider");
        }
      });

      $("#vq_slider_"+number).click(function(event) {
        sliderClicked(event)
      });
      $("#banned_slider_"+number).click(function(event) {
        sliderClicked(event)
      });

      $("#title_div_"+number).mouseover(function() {
          ControlBar.unfocus();
          VqPanel.setSelectedSlider(number);
          setSelection("sticker")
      });
      $("#sticker_hover_"+number).click(function() {
          ControlBar.unfocus();
          VqPanel.setSelectedSlider(number);
          if (selected != "sticker") {
            setSelection("sticker")
          };
          enterPressed();
      });
    }
  }

  function sliderClicked(event) {
    var x = event.pageX - $("#vq_slider_"+number).offset().left;
    var y = event.pageY - $("#vq_slider_"+number).offset().top;
    Putpat.debug(" : " + x + "... " + y);

    if (y > 15 && y < 357 && x > 100 && x < 127) {
      VqPanel.setSelectedSlider(number);
      if (y < 307) {
        slider.slider_value = Math.round(100 - ((y - 15) / 2.97));
      } else {
        slider.slider_value = -1;
      }
      slider["enabled"] = true;
      setSelection("slider");
      updateSlider();
    }
  }

  function getTitle() {
    if (titleEl == null) {
      titleEl = $("#title_" + number);
    }
    return titleEl;
  }

  function getSticker() {
    if (stickerEl == null) {
      stickerEl = $("#sticker_"+number);
    }
    return stickerEl;
  }

  function updateSlider() {
    if (slider.slider_value == 0) {
      getSticker().attr("src", Positions.size+"images/vq/sticker_disabled.png");
      getTitle().empty();
      $("#banned_slider_" + number).hide();
    } else if (slider.slider_value < 0) {
      getSticker().attr("src", Positions.size+"images/vq/sticker_banned.png");
      $("#banned_slider_" + number).show();
      getTitle().css("color", "red");
    } else {
      getSticker().attr("src", Positions.size+"images/vq/sticker_normal.png");
      getTitle().css("color", "black");
      $("#banned_slider_" + number).hide();
    }
    if (slider.slider_value > 0) {
      $("#slide_percent_" + number).empty().append(slider.slider_value);
      $("#slide_percent_div_" + number).show();
    } else {
      $("#slide_percent_div_" + number).hide();
    }

    if (slider.slider_value != 0) {
      getTitle().empty().append(slider.title);
    }
    if (slider.slider_value > 0) {
      $("#slider_highlight_" + number).css('background-color', Utils.convertColor(slider.color));
    } else {
      $("#slider_highlight_" + number).css('background-color', "#000000");
    }

    if (slider.slider_value < 0) {
      $("#slider_button_" + number).css("top", Positions.veequalizer.slider.banned + "px");
      $("#slider_black_" + number).css("height", Positions.veequalizer.slider.banned + "px");
    } else {
      var min = Positions.veequalizer.slider.min;
      var max = Positions.veequalizer.slider.max;
      var pos = min - ((min - max) / 100 * slider.slider_value);
      $("#slider_button_" + number).css("top", pos + "px");
      $("#slider_black_" + number).css("height", pos + "px");
    }

    updateDecades();
  }

  function updateDecades() {
    for (var i=0;i<5;i++) {
      $("#decade_highlight_"  + number + "_" + i).css('background-color', "#363636");
    }

    if ((slider.slider_value > 0) && slider.decades) {
      $.each(slider.decades, function(i, decade) {
        var p = 4 - (decade.year - 1970) / 10;
        if (p < 0) {
          p = 0;
        }
        $("#decade_highlight_" + number + "_"+ p).css('background-color', Utils.convertColor(slider.color));
      });
    }
  }

  function resetButtonState() {
    mode = null;
    $("#sticker_hover_"+number).hide();
    $("#slide_hover_"+number).hide();
    $("#decade_hover_"+number).hide();
    $("#decade_selector_"+number).hide();
    $("#slider_button_"+number).attr('src',Positions.size+"images/vq/slider_button.png");
    if (slider.slider_value == 0) {
      getSticker().attr("src", Positions.size+"images/vq/sticker_disabled.png");
      getTitle().empty();
    } else if (slider.slider_value < 0) {
      getSticker().attr("src", Positions.size+"images/vq/sticker_banned.png");
    } else {
      getSticker().attr("src", Positions.size+"images/vq/sticker_normal.png");
    }
  }

  function setSelection(sel) {
    if (slider.slider_value <= 0 && sel == "decades") {
      sel = "slider"
    } else if (slider.slider_value == 0 && slider.title == null && sel != "sticker") {
      sel = "sticker"
    }

    selected = sel;
    resetButtonState();

    switch(selected) {
      case "sticker":
         $("#sticker_hover_"+number).show();
         if (slider.slider_value == 0) {
           getSticker().attr("src", Positions.size+"images/vq/sticker_normal.png");
           getTitle().empty().append(slider.title);
           getTitle().css("color", "black");
         }
         break;
      case "decades":
         $("#decade_hover_"+number).show();
         break;
      case "slider":
         $("#slide_hover_"+number).show();
         if (slider.slider_value == 0) {
           getSticker().attr("src", Positions.size+"images/vq/sticker_normal.png");
           getTitle().empty().append(slider.title);
           getTitle().css("color", "black");
         }
         break;
    }
  }

  function updateDecateSelector() {
    $("#decade_selector_"+number).show();
    $("#decade_selector_"+number).css("top", Positions.veequalizer.decade[yearPos]+"px");
  }

  function toggleDecade() {
    var found = false;
    var newDecades = [];
    if (slider.decades != null) {
      $.each(slider.decades, function(i, decade) {
        var p = 4 - (decade.year - 1970) / 10;
        if (p < 0) {
          p = 0;
        }
        if (p == yearPos) {
          found = true;
        } else {
          newDecades.push(decade);
        }
      });
    }
    slider.decades = newDecades;
    if (!found) {
      var newYear = (4-yearPos) * 10 + 1970;
      if (yearPos == 0) {
        newYear = Putpat.getTime().getFullYear();
      }
      slider.decades.push({year: newYear});
    }
    updateDecades();
  }

  function moveLeft() {
    if (selected == "sticker") {
      return "LEFT_STICKER";
    } else if (selected == "decades") {
      return "LEFT_SLIDER";
    } else if (selected == "slider" && (slider.slider_value > 0)) {
      setSelection("decades");
    } else {
      return "LEFT_SLIDER";
    }
  }

  function moveRight() {
    if (selected == "sticker") {
      return "RIGHT_STICKER";
    } else if (selected == "slider") {
      return "RIGHT_DECADES";
    } else if (selected == "decades") {
      setSelection("slider");
    }
  }

  function moveUp() {
    if (mode == "slider") {
      if (slider.slider_value == -1) {
        slider.slider_value = 0;
      } else {
        slider.slider_value += 20;
        if (slider.slider_value > 100) {
          slider.slider_value = 100;
        }
      }
      slider["enabled"] = true;
      updateSlider();
    } else if (mode == "decade") {
      if (yearPos > 0) {
        yearPos--;
        updateDecateSelector();
      }
    } else if (selected == "sticker") {
      setSelection("slider");
    }
  }

  function moveDown() {
    if (mode == "slider") {
      if (slider.slider_value == 0) {
        slider.slider_value = -1;
      } else {
        slider.slider_value -= 20;
        if (slider.slider_value < 0) {
          slider.slider_value = 0;
        }
      }
      slider["enabled"] = true;
      updateSlider();
    } else if (mode == "decade") {
      if (yearPos < 4) {
        yearPos++;
        updateDecateSelector();
      }
    } else if (selected == "decades" || selected == "slider") {
      setSelection("sticker");
    } else {
      return "DOWN";
    }
  }

  function enterPressed() {
    if (selected == "slider" && mode =="slider") {
      mode = null;
      $("#slide_hover_"+number).show();
      $("#slider_button_"+number).attr("src", Positions.size+"images/vq/slider_button.png");
    } else if (selected == "slider") {
      mode = "slider";
      $("#slide_hover_"+number).hide();
      $("#slider_button_"+number).attr("src", Positions.size+"images/vq/slider_button_hover.png");
    } else if (selected == "decades") {
      if (mode == "decade") {
        toggleDecade();
      } else {
        mode = "decade";
        yearPos = 0;
        updateDecateSelector();
      }
    } else if (selected == 'sticker') {
      completer = VqCompleter(self).show();
    }
  }

  self.keyboardHandler = function(event) {
    var keycode = event.keyCode;
    switch(keycode) {
        case KEYS.KEY_LEFT:
            return moveLeft();
            break;
        case KEYS.KEY_RIGHT:
            return moveRight();
            break;
        case KEYS.KEY_UP:
            return moveUp();
            break;
        case KEYS.KEY_DOWN:
            return moveDown();
            break
        case KEYS.KEY_ENTER:
            return enterPressed();
            break
    }
  }

  self.select = function(pos) {
    setSelection(pos);
  }

  self.unselect = function() {
    selected = null;
    resetButtonState();
  }

  self.setSlider = function(s) {
    slider = s;
    updateSlider();
  }

  self.getSlider = function() {
    return slider;
  }

  self.updateSlider = function(data) {
    slider["slider_value"] = data["slider_value"] ;
    slider["title"] = data["title"];
    slider["id"] = data["id"];
    slider["color"] = data["color"];
    slider["type"] = data["type"];
    delete slider["decades"];
    slider["enabled"] = true;
    updateSlider();
    setSelection("slider");
  }

  self.number = function() {
    return number;
  }

  init();
  return self;
};
